#!/usr/bin/env python3

from math import *

def is_prime(n):
    if n == 0 or n == 1: return False
    for i in range (2, int(n**0.5) + 1):
        if n%i==0:
            return False
    return True

def int2str(n, base):
    digits = "0123456789abcdefghijklmnopqrstuvwxyz"
    if not 2 <= base <= 36: raise ValueError("Invalid base")
    if n < base:
        return digits[n]
    else:
        return int2str(n//base, base) + digits[n%base]

def is_emirp(n):
    if not is_prime(n): return False
    # turn n around
    reverseint = int((int2str(n, 10))[::-1])
    if (reverseint == n):
        return False
    elif (is_prime(reverseint)):
        return True
    else:
        return False

def main():
    # Hier kann beliebiger Testcode stehen, der bei der Korrektur ignoriert wird
    # Beispiel:
    for n in [1, 2, 3, 4, 5, 6, 7, 97, 98, 99]:
        print("Ist " + str(n) + " eine Primzahl? " + str(is_prime(n)))


    # Beispiel:
    print("Mirpzahlen: ", end='')
    for n in range(99):
        if is_emirp(n):
            print(' ' + str(n), end='')


if __name__ == "__main__": main()
