#!/usr/bin/env python3

import numpy as np
import math

def sign(x): return 1 if x>= 0 else -1

def givens_rotation(A, i, j):
    """Return the rotation matrix J, such that (J @ A)[i,j] = 0.0"""
    sigma = sign(A[j,j])
    p = math.sqrt((A[j,j])**2 + (A[i,j])**2)
    c = A[j,j]*sigma/p
    s = A[i,j]*sigma/p

    J = np.eye(A.shape[0])
    J[j,j] = c
    J[i,i] = c
    J[i,j] = -s
    J[j,i] = s
    return J


def qr_decompose(A):
    """Return (Q, R), such that A = Q @ R"""
    m = A.shape[0]
    n = A.shape[1]
    print("n")
    print (n)
    print("m")
    print(m)
    Q = np.eye(m)
    nstar = min(m-1,n)
    for j in range(0, nstar):
        print(j)
        for i in range (j+1, m):
            print ("meow")
            J = givens_rotation(A, i, j)
            print(J)
            Q = Q@np.transpose(J)
            A = J@A
    return (Q,A)


def backward_substitute(R, y):
    """Return x such that R @ x = y"""
    col = R.shape[1]
    row = R.shape[0]
    x = np.zeros((col,1))
    for i in range (row-1, -1,-1):
        x[i] = y[i]
        for j in range (i+1,col):
            x[i] = x[i] - R[i][j]*x[j]
        x[i] = x[i] / R[i][i]
    return x


def linsolve(A, *bs):
    """Return (x1, ..., xn), such that A @ xk = bs[k]"""
    a = []
    for b in bs:
        Q, R = qr_decompose(A)
        z = np.transpose(Q)@b
        x = backward_substitute(R, z)
        a.append(x)
    return tuple(a)


def main():
    # Hier kann beliebiger Testcode stehen, der bei der Korrektur ignoriert wird
    print(qr_decompose(np.array([[ 3.],[ 4.]])))
    pass


if __name__ == "__main__": main()

